diff -U 3 -H -d -r -N -- src/Fl_Calendar.cxx src/Fl_Calendar.cxx
--- src/Fl_Calendar.cxx	1970-01-01 05:00:00.000000000 +0500
+++ src/Fl_Calendar.cxx	2013-12-21 13:34:05.332764818 +0600
@@ -0,0 +1,1369 @@
+// Fl_Calendar (written by "Dmitrij K" <kdiman at live dot ru>) for the Fast Light Tool Kit (FLTK).
+//  license:   http://www.fltk.org/COPYING.php
+
+#ifndef Fl_Calendar_cxx
+#define Fl_Calendar_cxx
+
+#include <FL/Fl_Calendar.H>
+#include <FL/fl_draw.H>
+#include <FL/Fl_Button.H>
+
+// g++ -I/usr/local/include/FL -I../ -c Fl_Calendar.cxx
+
+
+
+/// +++++++++++++++++TIME FUNCTIONS+++++++++++++++++++++
+
+// args of next function taking from `struct tm' (see `get_nweek_gm')
+int Fl_Calendar::get_nweek(int year, int yday, int mon, int mday, int wday){
+ // http://en.wikipedia.org/wiki/ISO_week_date#Calculating_the_week_number_of_a_given_date
+ if(mon < 0 || mon > 11){ return -1; }
+ 
+ year += 1900;
+ 
+ if(wday == 0){ wday = 7; } // needs format from 1 to 7 (Monday ... Sunday)
+ 
+ int table_cnw[12] = {0,31,59,90,120,151,181,212,243,273,304,334};
+ 
+ int d = table_cnw[mon] + mday + 10 - wday;
+ if(mon > 1 && ((year % 4) == 0 && ((year % 100) != 0 || (year % 400) == 0))){ d++; }
+ 
+ return d/7;
+}
+
+
+
+// get number of week
+int Fl_Calendar::get_nweek_gm(const time_t target){
+struct tm *t=gmtime(&target);
+if(t == NULL){ return 0; }
+
+return get_nweek(t->tm_year, t->tm_yday, t->tm_mon, t->tm_mday, t->tm_wday);
+}
+
+int Fl_Calendar::get_nweek_local(const time_t target){
+struct tm *t=localtime(&target);
+if(t == NULL){ return 0; }
+
+return get_nweek(t->tm_year, t->tm_yday, t->tm_mon, t->tm_mday, t->tm_wday);
+}
+
+int Fl_Calendar::get_nweek(struct tm *t){
+if(t == NULL){ return 0; }
+
+return get_nweek(t->tm_year, t->tm_yday, t->tm_mon, t->tm_mday, t->tm_wday);
+}
+
+// for detect leap year [example: 2013]
+int Fl_Calendar::is_leap_year (int year){
+ return (year % 4) == 0 && ((year % 100) != 0 || (year % 400) == 0);
+}
+
+
+// get number of days in month  `mon[0..11]'
+int Fl_Calendar::get_ndays(int year, int mon){
+ year += 1900;
+ int ret = 0;
+ if(mon >= 0 && mon < 12){
+  if(mon <= 6){
+   if(mon == 1){ ret =  ((year % 4) == 0 && ((year % 100) != 0 || (year % 400) == 0))?29:28; }
+   else {
+    if(mon%2){ ret = 30; }
+    else { ret = 31; }
+   }
+  }
+  else{
+   if(mon%2){ ret = 31; }
+   else { ret = 30; }
+  }
+ }
+ return ret;
+}
+
+
+// get number of days in previous month for `mon'
+int Fl_Calendar::get_ndays_pm(int year, int mon){
+ year += 1900;
+ int ret = 0;
+ 
+ mon--;
+ if(mon < 0){
+  mon = 11;
+  year--;
+ }
+ 
+  if(mon <= 6){
+   if(mon == 1){ ret =  ((year % 4) == 0 && ((year % 100) != 0 || (year % 400) == 0))?29:28; }
+   else {
+    if(mon%2){ ret = 30; }
+    else { ret = 31; }
+   }
+  }
+  else{
+   if(mon%2){ ret = 31; }
+   else { ret = 30; }
+  }
+ return ret;
+}
+
+
+// get number of days in next month for `mon'
+int Fl_Calendar::get_ndays_nm(int year, int mon){
+ year += 1900;
+ int ret = 0;
+ 
+ mon++;
+ if(mon > 11){ mon = 0; year++; }
+ 
+  if(mon <= 6){
+   if(mon == 1){ ret =  ((year % 4) == 0 && ((year % 100) != 0 || (year % 400) == 0))?29:28; }
+   else {
+    if(mon%2){ ret = 30; }
+    else { ret = 31; }
+   }
+  }
+  else{
+   if(mon%2){ ret = 31; }
+   else { ret = 30; }
+  }
+ return ret;
+}
+
+
+// returns day of week [0-6] where 0 is Sunday, 1 is Monday, ... 6 is Saturday .
+// args for function taking from `struct tm' 
+int Fl_Calendar::get_wday(int year, int mon, int mday){
+ //http://www.faqs.org/faqs/calendars/faq/part1/index.html  - 2.6
+ mon++; // months: needs format from 1 to 12
+ int a = (14 - mon) / 12;
+ int y = year+1900 - a;
+ int m = mon + 12*a - 2;
+ int d = (mday + y + y/4 - y/100 + y/400 + (31*m)/12) % 7; // gregorian
+ //int d = (5 + mday + y + y/4 + (31*m)/12) % 7; // Julian
+ return d;
+}
+
+
+
+int Fl_Calendar::get_yday(int year, int mon, int mday){
+ int ret = 0;
+ int ndays = get_ndays(year, mon);
+ 
+ if(mday < 1 || mday > ndays){ return -1; }
+ if(mon < 0 || mon > 11){ return -1; }
+ 
+ for(int _i = 0; _i < mon; _i++){ ret += get_ndays(year, _i); }
+ ret += mday;
+ 
+ return ret;
+}
+
+
+
+#ifdef _WIN32
+time_t Fl_Calendar::timegm(struct tm *tm){
+    time_t ret;
+    char *tz;
+    char tmp[100];
+ 
+    tz = getenv("TZ");
+    putenv ("TZ=");
+    tzset();
+    ret = mktime(tm);
+    if (tz)
+    {
+       snprintf (tmp, 100, "TZ=%s", tz);
+       putenv (tmp);
+    }
+    tzset();
+    return ret;
+}
+
+time_t Fl_Calendar::timelocal(struct tm *tm){ return mktime(tm); }
+
+
+const char * my_weekdays[] = { "sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"};
+const char * my_monthnames[] = { "january", "february", "march", "april", "may", "june", "july", "august", "september", "october", "november", "december"};
+
+static bool my_atoi(const char * & s, int & result, int low, int high, int offset){
+ bool ret = false;
+ char * end;
+ unsigned long num = strtoul(s, & end, 10);
+ if (num >= (unsigned long)low && num <= (unsigned long)high){
+  result = (int)(num + offset);
+  s = end;
+  ret = true;
+  }
+ return ret;
+}
+
+static char * strptime(const char *s, const char *format, struct tm *tm){
+ bool ret = true;
+ while(ret && *format && *s){
+  switch(*format){
+   case '%':{
+    ++format;
+    switch(*format){
+     case 'a':
+     case 'A':
+     tm->tm_wday = -1;
+     ret = false;
+     for(size_t i = 0; i < 7; ++ i){
+      size_t len = strlen(my_weekdays[i]);
+      if(!strncasecmp(my_weekdays[i], s, len)){
+       tm->tm_wday = i;
+       s += len;
+       ret = true;
+       break;
+      }
+      else if(!strncasecmp(my_weekdays[i], s, 3)){
+       tm->tm_wday = i;
+       s += 3;
+       ret = true;
+       break;
+      }
+     }
+     break;
+     case 'b':
+     case 'B':
+     case 'h':
+     tm->tm_mon = -1;
+     ret = false;
+     for(size_t i = 0; i < 12; ++ i){
+      size_t len = strlen(my_monthnames[i]);
+      if(!strncasecmp(my_monthnames[i], s, len)){
+       tm->tm_mon = i;
+       s += len;
+       ret = true;
+       break;
+      }
+      else if(!strncasecmp(my_monthnames[i], s, 3)){
+       tm->tm_mon = i;
+       s += 3;
+       ret = true;
+       break;
+      }
+     }
+     break;
+     case 'd':
+     case 'e':
+     ret = my_atoi(s, tm->tm_mday, 1, 31, -1);
+     break;
+     case 'D':{
+      const char * s_save = s;
+      ret = my_atoi(s, tm->tm_mon, 1, 12, -1);
+      if(ret && *s == '/'){
+       ++ s;
+       ret = my_atoi(s, tm->tm_mday, 1, 31, -1);
+       if(ret && *s == '/'){
+        ++ s;
+        ret = my_atoi(s, tm->tm_year, 0, 99, 0);
+        if(ret && tm->tm_year < 69) tm->tm_year += 100;
+       }
+      }
+      if(!ret) s = s_save;
+     }
+     break;
+     case 'H':
+     ret = my_atoi(s, tm->tm_hour, 0, 23, 0);
+     break;
+     case 'I':
+     ret = my_atoi(s, tm->tm_hour, 1, 12, 0);
+     break;
+     case 'j':
+     ret = my_atoi(s, tm->tm_yday, 1, 366, -1);
+     break;
+     case 'm':
+     ret = my_atoi(s, tm->tm_mon, 1, 12, -1);
+     break;
+     case 'M':
+     ret = my_atoi(s, tm->tm_min, 0, 59, 0);
+     break;
+     case 'n':
+     case 't':
+     while (isspace((int)*s)) ++s;
+     break;
+     case 'p':
+     if(!strncasecmp(s, "am", 2)){
+      if(tm->tm_hour == 12) tm->tm_hour = 0;
+     }
+     else if(!strncasecmp(s, "pm", 2)){
+      if(tm->tm_hour < 12) tm->tm_hour += 12;
+     }
+     else ret = false;
+     break;
+     case 'r':{
+      const char * s_save = s;
+      ret = my_atoi(s, tm->tm_hour, 1, 12, 0);
+      if(ret && *s == ':'){
+       ++ s;
+       ret = my_atoi(s, tm->tm_min, 0, 59, 0);
+       if(ret && *s == ':'){
+        ++ s;
+        ret = my_atoi(s, tm->tm_sec, 0, 60, 0);
+        if(ret && isspace((int)*s)){
+         ++ s;
+         while(isspace((int)*s)) ++s;
+         if(!strncasecmp(s, "am", 2)){
+          if(tm->tm_hour == 12) tm->tm_hour = 0;
+         }
+         else if(!strncasecmp(s, "pm", 2)){
+          if(tm->tm_hour < 12) tm->tm_hour += 12;
+         }
+         else ret = false;
+        }
+       }
+      }
+      if(!ret) s = s_save;
+     }
+     break;
+     case 'R':{
+      const char * s_save = s;
+      ret = my_atoi(s, tm->tm_hour, 0, 23, 0);
+      if(ret && *s == ':'){
+       ++ s;
+       ret = my_atoi(s, tm->tm_min, 0, 59, 0);
+      }
+      if(!ret) s = s_save;
+     }
+     break;
+     case 'S':
+     ret = my_atoi(s, tm->tm_sec, 0, 60, 0);
+     break;
+     case 'T':{
+      const char * s_save = s;
+      ret = my_atoi(s, tm->tm_hour, 0, 23, 0);
+      if(ret && *s == ':'){
+       ++ s;
+       ret = my_atoi(s, tm->tm_min, 0, 59, 0);
+       if(ret && *s == ':'){
+        ++ s;
+        ret = my_atoi(s, tm->tm_sec, 0, 60, 0);
+       }
+      }
+      if(!ret) s = s_save;
+     }
+     break;
+     case 'w':
+     ret = my_atoi(s, tm->tm_wday, 0, 6, 0);
+     break;
+     case 'Y':
+     ret = my_atoi(s, tm->tm_year, 1900, 65535, -1900);
+     break;
+     case 'y':
+     ret = my_atoi(s, tm->tm_year, 0, 99, 0);
+     if(ret && tm->tm_year < 69) tm->tm_year += 100;
+     break;
+     case '%':
+     if(*s != '%') ret = false;
+     ++s;
+     break;
+     default: ret = false;
+    }
+   }
+   break;
+   case ' ':
+   case '\t':
+   case '\r':
+   case '\n':
+   case '\f':
+   case '\v':
+   while(isspace((int)*s)) ++ s;
+   break;
+   default:
+   if(*s != *format) ret = false;
+   else ++s;
+   break;
+  }
+  ++format;
+ }
+ return (ret?(char *)s:NULL);
+}
+#endif
+/// +++++++++++++++++TIME FUNCTIONS+++++++++++++++++++++
+
+
+
+int Fl_Calendar::normal_wday(int _i){
+ if(_i >= 0 && _i <= 6){
+  if(_i == 0){ _i = 6; }
+  else { _i--; }
+ } else { _i = 0; }
+ return _i;
+}
+
+
+int Fl_Calendar::base_wday(int _i){
+ if(_i >= 0 && _i <= 6){
+  if(_i == 6){ _i = 0; }
+  else { _i++; }
+ } else { _i = 0; }
+ return _i;
+}
+
+
+
+
+
+static const char table_mdays[33][3] = { {"0"},{"1"},{"2"},{"3"},{"4"},{"5"},{"6"},{"7"},{"8"},{"9"},{"10"},{"11"},{"12"},{"13"},{"14"},{"15"},{"16"},{"17"},{"18"},{"19"},{"20"},{"21"},{"22"},{"23"},{"24"},{"25"},{"26"},{"27"},{"28"},{"29"},{"30"},{"31"},{0} };
+
+static const char table_nweeks[55][3] = { {"00"},{"01"},{"02"},{"03"},{"04"},{"05"},{"06"},{"07"},{"08"},{"09"},{"10"},{"11"},{"12"},{"13"},{"14"},{"15"},{"16"},{"17"},{"18"},{"19"},{"20"},{"21"},{"22"},{"23"},{"24"},{"25"},{"26"},{"27"},{"28"},{"29"},{"30"},{"31"},{"32"},{"33"},{"34"},{"35"},{"36"},{"37"},{"38"},{"39"},{"40"},{"41"},{"42"},{"43"},{"44"},{"45"},{"46"},{"47"},{"48"},{"49"},{"50"},{"51"},{"52"},{"53"},{0} };
+
+
+
+#define CLDR_COLS 8
+#define CLDR_ROWS 7
+#define H_ROW 32
+#define H_BOX 24
+#define W_BOX 115
+#define SIDE_OFFSET 4
+
+#define W_BTN 32
+#define H_BTN 20
+
+
+
+Fl_Calendar::Fl_Calendar(int X,int Y,int W,int H):Fl_Menu_Window(X,Y,W,H,0){
+  Fl_Menu_Window::resize(X,Y,calc_width(), calc_height());
+  Fl_Menu_Window::type(FL_DOUBLE_WINDOW);
+  //Fl_Menu_Window::when(FL_WHEN_CHANGED);
+  Fl_Menu_Window::callback((Fl_Callback*)0, 0);
+  
+  _year = _mon = _mday = 0;
+  memset(_sdays, 0, 42);
+  
+  _sel = NULL;
+  memset(&_tm, 0, sizeof(_tm));
+  
+  _ts = time(NULL);
+  memcpy(&_tm, localtime(&_ts), sizeof(_tm));
+  
+  _year = _tm.tm_year;
+  _mon = _tm.tm_mon;
+  _mday = _tm.tm_mday;
+  
+  int xx = SIDE_OFFSET, yy = SIDE_OFFSET, ww = W_BTN, hh = H_BTN;
+  
+  int off_y = (H_ROW-H_BOX)/2, off_x = 0;
+  
+  label(_prefs._header);
+  
+  off_x = (H_BOX+1);
+  _header = new Fl_Box(SIDE_OFFSET, yy, w()-SIDE_OFFSET*2, H_ROW, _prefs._header);
+  _header->labelcolor(_prefs._headercolor[1]);
+  _header->labelsize(_prefs._size_fonts[0]);
+  _header->labelfont(_prefs._fonts[0]);
+  _header->box(FL_THIN_UP_FRAME);
+  
+  
+  _icon = new Fl_Box(xx*2, yy+off_y, H_BOX, H_BOX, 0);
+  _icon->box(FL_NO_BOX); // FL_THIN_UP_FRAME
+  //_icon->down_box(FL_THIN_UP_BOX);
+  _icon->image(&_prefs._icon);
+  _icon->deimage(&_prefs._deicon);
+  
+  
+  yy += H_ROW+1; off_y = (H_ROW-H_BOX)/2; off_x = 0;
+  
+  _left_btn = new Fl_Nav_Repeat_Button(xx, yy+off_y, H_BOX, H_BOX);
+  _left_btn->align(FL_ALIGN_LEFT); _left_btn->box(FL_UP_BOX);
+  _left_btn->callback((Fl_Callback *)month_cb2, this);
+  
+  off_x = w()-SIDE_OFFSET-H_BOX;
+  _right_btn = new Fl_Nav_Repeat_Button(off_x, yy+off_y, H_BOX, H_BOX);
+  _right_btn->align(FL_ALIGN_RIGHT); _right_btn->box(FL_UP_BOX);
+  _right_btn->callback((Fl_Callback *)month_cb2, this);
+  
+  off_x = xx+H_BOX+10;
+  _months = new Fl_Choice(off_x, yy+off_y, W_BOX, H_BOX, 0);
+  _months->when(FL_WHEN_RELEASE);
+  _months->down_box(FL_THIN_DOWN_BOX);
+  _months->labelcolor(_prefs._monthscolor[1]);
+  _months->labelsize(_prefs._size_fonts[1]);
+  _months->labelfont(_prefs._fonts[1]);
+  _months->visible_focus(0);
+  
+  for(int _i = 0; _i < 12; _i++){
+   _months->add(_prefs._months[_i]);
+   Fl_Menu_Item &item = (Fl_Menu_Item &)(_months->menu()[_i]);
+   item.labelcolor(_prefs._monthscolor[1]);
+   item.labelsize(_prefs._size_fonts[1]);
+   item.labelfont(_prefs._fonts[1]);
+  }
+  _months->value(_mon);
+  _months->callback((Fl_Callback *)month_cb, this);
+  
+  off_x += W_BOX+10; ww = (w()-SIDE_OFFSET-H_BOX-10)-off_x;
+  
+  _years = new Fl_Spinner(off_x, yy+off_y, ww, H_BOX);
+  _years->range(0.0, 3000.0);
+  _years->value(_year+1900);
+  _years->labelcolor(_prefs._monthscolor[1]);
+  _years->labelsize(_prefs._size_fonts[1]);
+  _years->labelfont(_prefs._fonts[1]);
+  _years->callback((Fl_Callback *)year_cb, this);
+  _years->when(FL_WHEN_RELEASE|FL_WHEN_ENTER_KEY);
+  
+  xx = SIDE_OFFSET+W_BTN+2; yy += H_ROW+1; ww = W_BTN; off_y = yy;
+  char str[32]; memset(str, 0, 32);
+  
+  for(int _i = 0; _i < 7; _i++){
+   _nmdays[_i] = new Fl_Box(xx, yy, ww, hh, 0);
+   _nmdays[_i]->label(_prefs._days[_i]);
+   _nmdays[_i]->visible_focus(0);
+   _nmdays[_i]->box(FL_FLAT_BOX);
+   _nmdays[_i]->labelcolor(_prefs._dayscolor[1]);
+   _nmdays[_i]->labelsize(_prefs._size_fonts[1]);
+   _nmdays[_i]->labelfont(_prefs._fonts[1]);
+   xx += W_BTN+1;
+  }
+  
+  xx = SIDE_OFFSET; yy += H_BTN+1;
+  
+  for(int _i = 0; _i < 6; _i++){
+   _nweeks[_i] = new Fl_Box(xx, yy, ww, hh, 0);
+   //_nweeks[_i]->copy_label(table_nweeks[_i+1]);
+   _nweeks[_i]->visible_focus(0);
+   _nweeks[_i]->box(FL_FLAT_BOX);
+   _nweeks[_i]->labelcolor(_prefs._dayscolor[0]);
+   _nweeks[_i]->labelsize(_prefs._size_fonts[2]);
+   _nweeks[_i]->labelfont(_prefs._fonts[2]);
+   yy += H_BTN+1;
+  }
+  
+  
+  xx = SIDE_OFFSET+W_BTN+2; yy = off_y + H_BTN+1;
+  int nweek = get_nweek(_tm.tm_year, _tm.tm_yday, _tm.tm_mon, 1, _tm.tm_wday);
+  
+  int wday = normal_wday(get_wday(_tm.tm_year, _tm.tm_mon, 1));
+  int prev_ndays = get_ndays_pm(_tm.tm_year, _tm.tm_mon);
+  
+  int n_firstpday = prev_ndays-(wday-1);
+  int off_firstday = wday;
+  int off_lastday = off_firstday+get_ndays(_tm.tm_year, _tm.tm_mon);
+  
+  
+  for(int _i = 0, _d = 0, _wd = 0, _nw = 0; _i < 42; _i++, _d++){
+   
+   _days[_i] = new Fl_Button(xx, yy, W_BTN, H_BTN, 0);
+   //_days[_i]->when(FL_WHEN_ENTER_KEY);
+   ///sprintf(str, "%d", _i+1); _days[_i]->copy_label(str);
+   _days[_i]->type(FL_TOGGLE_BUTTON);
+   _days[_i]->visible_focus(0);
+   _days[_i]->box(FL_THIN_UP_BOX);
+   _days[_i]->down_box(FL_DOWN_FRAME);
+   //_days[_i]->labelcolor(_prefs._dayscolor[1]);
+   _days[_i]->selection_color(_prefs._dayscolor[2]);
+   _days[_i]->labelsize(_prefs._size_fonts[2]);
+   _days[_i]->labelfont(_prefs._fonts[2]);
+   
+   
+   if(!(_i%7)){ // first day of week
+    if(nweek >= 53){ nweek = 1; }
+    else if(nweek < 1){ nweek = 52; }
+    _nweeks[_nw]->label(table_nweeks[nweek]);
+    _nw++; nweek++;
+   }
+   
+   
+   if(_i < off_firstday){ /// days from previous month
+    if(_i == 0){ _d = n_firstpday; }
+    _sdays[_i] = -1;
+    _days[_i]->labelcolor(_prefs._dayscolor[0]);
+    _days[_i]->label(table_mdays[_d]);
+   }
+   
+   else if(_i >= off_lastday){ /// days from next month
+    _sdays[_i] = 1;
+    _days[_i]->labelcolor(_prefs._dayscolor[0]);
+    _days[_i]->label(table_mdays[_d]);
+   }
+   
+   else { /// days from current month
+    if(_i == off_firstday){ _d = 1; }
+    _sdays[_i] = 0;
+    _days[_i]->labelcolor(_prefs._dayscolor[1]);
+    _days[_i]->label(table_mdays[_d]);
+    if(_mday == _d && _mon == _months->value() && _year == (int(_years->value())-1900)){ // select current day
+     _days[_i]->down_box(FL_DOWN_BOX);
+     _days[_i]->value(1);
+     _sel = _days[_i];
+    }
+    if(_i == (off_lastday-1)){ _d = 0; }
+   }
+   
+   
+   
+   
+   if(_wd == 6){ _wd = 0; yy += H_BTN+1; xx = SIDE_OFFSET+W_BTN+2; }
+   else { _wd++; xx += W_BTN+1; }
+  }
+  
+  
+  xx = SIDE_OFFSET; off_x = 0; off_y = (H_ROW-H_BOX)/2-1;
+  
+  _iconupdate = new Fl_Button(xx+off_x, yy+off_y, H_BOX, H_BOX, 0);
+  _iconupdate->tooltip(_prefs._icontooltips[0]);
+  _iconupdate->visible_focus(0);
+  _iconupdate->box(FL_UP_BOX);
+  _iconupdate->down_box(FL_THIN_DOWN_BOX);
+  _iconupdate->image(&_prefs._iconupdate);
+  _iconupdate->deimage(&_prefs._deiconupdate);
+  _iconupdate->callback((Fl_Callback *)button_cb, this);
+  _iconupdate->when(FL_WHEN_RELEASE);
+  
+  xx += W_BTN+2;
+  
+  _iconreset = new Fl_Button(xx+off_x, yy+off_y, H_BOX, H_BOX, 0);
+  _iconreset->tooltip(_prefs._icontooltips[1]);
+  _iconreset->visible_focus(0);
+  _iconreset->box(FL_UP_BOX);
+  _iconreset->down_box(FL_THIN_DOWN_BOX);
+  _iconreset->image(&_prefs._iconreset);
+  _iconreset->deimage(&_prefs._deiconreset);
+  _iconreset->callback((Fl_Callback *)button_cb, this);
+  _iconreset->when(FL_WHEN_RELEASE);
+  
+  xx += H_BOX+9; ww = _years->w()-_years->w()/3;
+  
+  _weeks = new Fl_Spinner(xx, yy+off_y, ww, H_BOX);
+  _weeks->format("%02g");
+  _weeks->range(1.0, 52.0);
+  _weeks->labelcolor(_prefs._monthscolor[1]);
+  _weeks->labelsize(_prefs._size_fonts[1]);
+  _weeks->labelfont(_prefs._fonts[1]);
+  nweek = get_nweek(_tm.tm_year, _tm.tm_yday, _tm.tm_mon, _tm.tm_mday, _tm.tm_wday);
+  _weeks->value(nweek);
+  _weeks->callback((Fl_Callback *)week_cb, this);
+  _weeks->when(FL_WHEN_RELEASE|FL_WHEN_ENTER_KEY);
+  
+  
+  xx += _weeks->w()+10;
+  _clocks = new Fl_Clock_Spinner(xx, yy+off_y, _years->w(), H_BOX);
+  _clocks->labelcolor(_prefs._monthscolor[1]);
+  _clocks->labelsize(_prefs._size_fonts[1]);
+  _clocks->labelfont(_prefs._fonts[1]);
+  _clocks->set_values(_tm.tm_hour, _tm.tm_min);
+  _clocks->callback((Fl_Callback *)clock_cb, this);
+  _clocks->when(FL_WHEN_RELEASE|FL_WHEN_ENTER_KEY);
+  
+  xx = w()-SIDE_OFFSET-H_BOX*2-10;
+  _iconaccept = new Fl_Button(xx, yy+off_y, H_BOX, H_BOX, 0);
+  _iconaccept->tooltip(_prefs._icontooltips[2]);
+  _iconaccept->visible_focus(0);
+  _iconaccept->box(FL_UP_BOX);
+  _iconaccept->down_box(FL_THIN_DOWN_BOX);
+  _iconaccept->image(&_prefs._iconaccept);
+  _iconaccept->deimage(&_prefs._deiconaccept);
+  _iconaccept->callback((Fl_Callback *)button_cb, this);
+  _iconaccept->when(FL_WHEN_RELEASE);
+  
+  xx += H_BOX+10;
+  _iconcancel = new Fl_Button(xx, yy+off_y, H_BOX, H_BOX, 0);
+  _iconcancel->tooltip(_prefs._icontooltips[3]);
+  _iconcancel->visible_focus(0);
+  _iconcancel->box(FL_UP_BOX);
+  _iconcancel->down_box(FL_THIN_DOWN_BOX);
+  _iconcancel->image(&_prefs._iconcancel);
+  _iconcancel->deimage(&_prefs._deiconcancel);
+  _iconcancel->callback((Fl_Callback *)button_cb, this);
+  _iconcancel->when(FL_WHEN_RELEASE);
+  if(parent() != NULL){ _iconcancel->deactivate(); }
+  
+  end();
+  //set_modal();
+  //border(0);
+  //set_prefs(&_prefs);
+  box(FL_THIN_UP_BOX);
+  color(fl_lighter(FL_BACKGROUND_COLOR));
+  
+  _cach = true;
+  _rdo = false;
+  
+  
+  
+  
+ }
+
+
+
+
+
+
+void Fl_Calendar::set(int mday, int mon, int year, int hour, int min, int sec/*, bool chs*/){
+ year -= 1900; // correct with the tm structure
+ bool upd = false;
+ int ndays = 0;
+ 
+//  int o_year = _tm.tm_year;
+//  int o_mon = _tm.tm_mon;
+//  int o_mday = _tm.tm_mday;
+//  int o_yday = _tm.tm_yday;
+//  int o_wday = _tm.tm_wday;
+ 
+ 
+ // changed year ?
+ if((year+1900) != -1 && year != _tm.tm_year){
+  _tm.tm_year = year;
+  _years->value(year+1900);
+  upd = true;
+ }
+ 
+ if(mon < -1){ mon = 0; }
+ else if(mon > 11){ mon = 11; }
+ if(mon != -1 && mon != _tm.tm_mon){
+  _tm.tm_mon = mon;
+  _months->value(mon);
+  upd = true;
+ }
+ 
+ ndays = get_ndays(_tm.tm_year, _tm.tm_mon);
+ 
+ if(mday < -1){ mday = 1; }
+ else if(mday > ndays){ mday = ndays; }
+ if(mday != -1 && mday != _tm.tm_mday){
+  _tm.tm_mday = mday;
+  upd = true;
+ } else if(_tm.tm_mday > ndays){
+  _tm.tm_mday = ndays;
+  upd = true;
+ }
+ 
+ if(hour < -1){ hour = 0; } else if(hour > 23){ hour = 23; }
+ if(min < -1){ min = 0; } else if(min > 59){ min = 59; }
+ if(sec < -1){ sec = 0; } else if(sec > 59){ sec = 59; }
+ 
+ if(sec != -1 && sec != _tm.tm_sec){ _tm.tm_sec = sec; }
+ 
+ 
+ if(hour != -1 && hour != _tm.tm_hour){
+  _tm.tm_hour = hour;
+  _clocks->hours(hour);
+  
+  if(min < -1){ min = 0; }
+ else if(min > 59){ min = 59; }
+ if(min != -1 && min != _tm.tm_min){
+  _tm.tm_min = min;
+  _clocks->minutes(min);
+ }
+ 
+ if(!upd){ /*_clocks->redraw();*/ return; }
+ }
+ 
+ 
+ else if(min != -1 && min != _tm.tm_min){
+  _tm.tm_min = min;
+  _clocks->minutes(min);
+  if(!upd){ /*_clocks->redraw();*/ return; }
+ }
+ 
+ if(!upd){ return; }
+ 
+ _tm.tm_yday = get_yday(_tm.tm_year, _tm.tm_mon, _tm.tm_mday);
+ _tm.tm_wday = get_wday(_tm.tm_year, _tm.tm_mon, _tm.tm_mday);
+ 
+ int wday = get_wday(_tm.tm_year, _tm.tm_mon, 1);
+ int nweek = get_nweek(_tm.tm_year, _tm.tm_yday, _tm.tm_mon, 1, wday);
+ wday = normal_wday(wday);
+ int prev_ndays = get_ndays_pm(_tm.tm_year, _tm.tm_mon);
+ 
+ int n_firstpday = prev_ndays-(wday-1); // number of last month which is beginning in first button of days
+ int off_firstday = wday; // offset for first number of current month in the array's _days[42]
+ int off_lastday = off_firstday+ndays; // offset for first day of next month
+ 
+ 
+ // if first  button of days has label 1 needs to shift it on 7 elements to forward
+ if(off_firstday == 0){
+  //printf("SHIFT: 7>>\n");
+  n_firstpday -= 7;
+  off_firstday += 7;
+  off_lastday += 7;
+  nweek--;
+ } else if(off_lastday == 42){
+  //printf("SHIFT: <<7\n");
+  n_firstpday += 7;
+  off_firstday -= 7;
+  off_lastday -= 7;
+  nweek++;
+ }
+ 
+ 
+ int sel_omday = -1;
+ sel_omday = _tm.tm_mday;
+ 
+//  // fixing old selected day
+//  if(!chs){ for(int _i = 0; _i < 42; _i++){
+//   if(_days[_i]->value()){
+//    if(_days[_i]->down_box() == FL_DOWN_BOX){
+//     if(sel_omday == -1){ sel_omday = strtol(_days[_i]->label(), NULL, 10); }
+//    } else { sel_omday = strtol(_days[_i]->label(), NULL, 10); }
+//   }
+//  } } else { sel_omday = _tm.tm_mday; }
+ 
+ 
+ _sel = NULL;
+ 
+ int py = _tm.tm_year;
+ int pm = _tm.tm_mon-1; if(pm < 0){ pm = 11; py--; }
+ 
+ int ny = _tm.tm_year;
+ int nm = _tm.tm_mon+1; if(nm > 11){ nm = 0; ny++; }
+ 
+ 
+  for(int _i = 0, _d = 0, _wd = 0, _nw = 0; _i < 42; _i++, _d++){
+   
+   _days[_i]->box(FL_THIN_UP_BOX);
+   _days[_i]->down_box(FL_THIN_DOWN_BOX);
+   //_days[_i]->down_box(FL_DOWN_FRAME);
+   _days[_i]->selection_color(_prefs._dayscolor[2]);
+   _days[_i]->value(0);
+   
+   if(!(_i%7)){ // first day of week
+    if(nweek >= 53){ nweek = 1; }
+    else if(nweek < 1){ nweek = 52; }
+    _nweeks[_nw]->label(table_nweeks[nweek]);
+    _nw++; nweek++;
+   }
+   
+   
+   if(_i < off_firstday){ /// days from previous month
+    if(_i == 0){ _d = n_firstpday; }
+    _sdays[_i] = -1;
+    _days[_i]->labelcolor(_prefs._dayscolor[0]);
+    _days[_i]->label(table_mdays[_d]);
+    if(_mday == _d && _mon == pm && _year == py){
+     _days[_i]->down_box(FL_DOWN_BOX); _days[_i]->value(1);
+    }
+   }
+   
+   else if(_i >= off_lastday){ /// days from next month
+    _sdays[_i] = 1;
+    _days[_i]->labelcolor(_prefs._dayscolor[0]);
+    _days[_i]->label(table_mdays[_d]);
+    if(_mday == _d && _mon == nm && _year == ny){
+     _days[_i]->down_box(FL_DOWN_BOX); _days[_i]->value(1);
+    }
+   }
+   
+   else { /// days from current month
+    if(_i == off_firstday){ _d = 1; }
+    _sdays[_i] = 0;
+    _days[_i]->labelcolor(_prefs._dayscolor[1]);
+    _days[_i]->label(table_mdays[_d]);
+    if(_mday == _d && _mon == _months->value() && _year == (int(_years->value())-1900)){ // select current day
+     _days[_i]->down_box(FL_DOWN_BOX); _days[_i]->value(1);
+     if(_sel == NULL){ _sel = _days[_i]; _weeks->value(nweek-1); }
+    } else if(_d == sel_omday){
+     _days[_i]->selection_color(fl_color_average(_prefs._dayscolor[2], FL_WHITE, 0.35));
+     _days[_i]->value(1);
+     _sel = _days[_i];
+     _weeks->value(nweek-1);
+    }
+    if(_i == (off_lastday-1)){ _d = 0; }
+   }
+   
+   if(_wd == 6){ _wd = 0; }
+   else { _wd++; }
+  }
+ 
+ 
+//  if(_sel != NULL && _sel->down_box() != FL_DOWN_BOX){
+//   int X=x()+_sel->x(), Y=y()+_sel->y(), W=_sel->w(), H=_sel->h();
+// //   fl_push_clip(X, Y, W, H);
+// //   fl_rectf(X+2, Y+2, W-4, H-4, fl_lighter(FL_BACKGROUND_COLOR));
+// //   fl_pop_clip();
+//   
+//   //damage_resize(x(), y(), w(), h());
+//   _sel->redraw_label();
+//   _sel->set_changed();
+//   set_changed();
+//  }
+ 
+ 
+}
+
+
+
+
+
+
+void Fl_Calendar::week_cb(Fl_Spinner* w, Fl_Calendar *a){
+  if(a->_sel == NULL){ return; }
+  int new_nweek = (int)a->_weeks->value();
+  int year = a->_years->value()-1900;
+  int mon = a->_months->value();
+  int mday = strtol(a->_sel->label(), NULL, 10);
+  int wday = get_wday(year, mon, mday);
+  int yday = get_yday(year, mon, mday);
+  int nweek = get_nweek(year, yday, mon, mday, wday);
+  int o_index = -1, tmp_i = -1;
+  int n_mday = -1;
+  for(int _i = 0; _i < 42; _i++){ if(a->_sel == a->_days[_i]){ o_index = _i; break; } }
+  if(o_index < 0){ return; }
+  
+  if(new_nweek != nweek && a->_sel->down_box() != FL_DOWN_BOX){ a->_sel->value(0); }
+  
+  // week down ?
+  if(new_nweek < nweek){
+   
+   // BUG : incorrect going sometime
+   if(nweek == 52 && new_nweek == 1){
+    goto L_UPWEEK;
+    //tmp_i = o_index+7;
+    //if(/*tmp_i >= 42 ||*/ (tmp_i < 42 && a->_sdays[tmp_i] == 0)){ goto L_UPWEEK; }
+   }
+   
+   L_DOWNWEEK:
+   if((tmp_i = o_index-7) >= 0 && tmp_i < 42){
+    n_mday = strtol(a->_days[tmp_i]->label(), NULL, 10);
+    
+    if(a->_sdays[tmp_i] == -1){ // day of previous month
+     mon--;
+     if(mon < 0){ mon = 11; year--; }
+    } else if(a->_sdays[tmp_i] == 1){ // day of next month
+     mon++;
+     if(mon > 11){ mon = 0; year++; }
+    }
+    a->_sel = a->_days[tmp_i];
+   } else { // tmp_i is less 0
+    n_mday = strtol(a->_days[0]->label(), NULL, 10);
+    
+    if(n_mday == 1){ n_mday = get_ndays_pm(year, mon)+1; }
+    n_mday += tmp_i;
+    
+    for(int _i = 41; _i >= 0; _i--){
+     if(strtol(a->_days[_i]->label(), NULL, 10) == n_mday){ tmp_i = _i; break; }
+    }
+    mon--;
+    if(mon < 0){ mon = 11; year--; }
+    a->_sel = a->_days[tmp_i];
+   }
+   
+   a->_sel->value(1);
+   a->set(n_mday, mon, year+1900);
+  } // end week down
+  
+  // week up ?
+  else if(new_nweek > nweek){
+   
+   // BUG : incorrect going sometime
+   if(nweek == 1 && new_nweek == 52){
+    goto L_DOWNWEEK;
+    //tmp_i = o_index-7;
+    //if(/*tmp_i < 0 ||*/ (tmp_i >= 0 && a->_sdays[tmp_i] == 0)){ goto L_DOWNWEEK; }
+   }
+   
+   L_UPWEEK:
+   if((tmp_i = o_index+7) < 42 && tmp_i >= 0){
+    
+    n_mday = strtol(a->_days[tmp_i]->label(), NULL, 10);
+    
+    if(a->_sdays[tmp_i] == -1){ // day of previous month
+     mon--;
+     if(mon < 0){ mon = 11; year--; }
+    } else if(a->_sdays[tmp_i] == 1){ // day of next month
+     mon++;
+     if(mon > 11){ mon = 0; year++; }
+    }
+    a->_sel = a->_days[tmp_i];
+    
+   } else { // tmp_i is more than 41
+    n_mday = strtol(a->_days[41]->label(), NULL, 10);
+    
+    if(n_mday == 1){ n_mday = get_ndays_nm(year, mon)-1; }
+    n_mday -= tmp_i;
+    
+    for(int _i = 0; _i < 42; _i++){
+     if(strtol(a->_days[_i]->label(), NULL, 10) == n_mday){ tmp_i = _i; break; }
+    }
+    mon++;
+    if(mon > 11){ mon = 0; year++; }
+    a->_sel = a->_days[tmp_i];
+   }
+   
+   a->_sel->value(1);
+   a->set(n_mday, mon, year+1900);
+   
+  } // end week up
+  
+ }
+
+ 
+ #include <FL/names.h>
+
+ void Fl_Calendar::button_cb(Fl_Button* w, Fl_Calendar *a){
+  
+  if(w == a->_iconupdate){
+   if(a->readonly()){ return ; }
+   a->_ts = time(NULL);
+   struct tm tm; memset(&tm, 0, sizeof(tm));
+   memcpy(&tm, localtime(&a->_ts), sizeof(tm));
+   a->_year=tm.tm_year; a->_mon=tm.tm_mon; a->_mday=tm.tm_mday;
+   a->set(tm.tm_mday, tm.tm_mon, tm.tm_year+1900, tm.tm_hour, tm.tm_min, tm.tm_sec);
+  }
+  
+  else if(w == a->_iconreset){
+   a->set(a->_mday, a->_mon, a->_year+1900);
+  }
+  
+  else if(w == a->_iconaccept){
+   if(a->readonly()){ return ; }
+   a->_year=a->_tm.tm_year; a->_mon=a->_tm.tm_mon; a->_mday=a->_tm.tm_mday;
+   int ny = a->_tm.tm_year+1900;
+   int nh = a->_tm.tm_hour, nm = a->_tm.tm_min, ns = a->_tm.tm_sec;
+   // HACK : needs for redrawing ...
+   a->_tm.tm_year=~a->_tm.tm_year;
+   a->_tm.tm_min=~a->_tm.tm_min;
+   a->set(a->_tm.tm_mday, a->_tm.tm_mon, ny, nh, nm, ns);
+   Fl_Widget *p=Fl::pushed();
+   if(a->callback() && a->shown() && (p == w || Fl::event() == FL_RELEASE)){ a->do_callback(); }
+  }
+  
+  else if(w == a->_iconcancel){
+   if(a->parent() != NULL){ a->_iconcancel->deactivate(); }
+   else { a->hide(); }
+  }
+  
+ }
+
+ 
+ 
+
+ void Fl_Calendar::clock_cb(Fl_Clock_Spinner* w, Fl_Calendar *a){
+  a->set(-1, -1, -1, a->_clocks->hours(), a->_clocks->minutes());
+ }
+ 
+ void Fl_Calendar::year_cb(Fl_Spinner* w, Fl_Calendar *a){
+  a->set(-1, -1, (int)a->_years->value());
+ }
+ 
+ void Fl_Calendar::month_cb(Fl_Choice* w, Fl_Calendar *a){
+  a->set(-1, a->_months->value(), -1);
+ }
+ 
+ 
+ void Fl_Calendar::month_cb2(Fl_Nav_Repeat_Button* w, Fl_Calendar *a){
+  int ny = (int)a->_years->value();
+  int nm = a->_months->value();
+  if(w == a->_left_btn){
+   nm--; if(nm < 0){ nm = 11; ny--; }
+   a->set(-1, nm, ny);
+  }
+  else if(w == a->_right_btn){
+   nm++; if(nm > 11){ nm = 0; ny++; }
+   a->set(-1, nm, ny);
+  }
+ }
+ 
+ 
+ 
+int Fl_Calendar::calc_width(){
+ int ret = SIDE_OFFSET*2; // 4px from left, and 4px from right space
+ ret += 8*(W_BTN+1);
+ 
+ return ret;
+}
+
+
+int Fl_Calendar::calc_height(){
+ int ret = SIDE_OFFSET*2; // 4px from top, and 4px from bottom space
+ 
+ ret += H_ROW; // header height
+ ret += H_ROW; // month_choice&year_spinner height
+ ret += 7*(H_BTN+1);
+ ret += H_ROW-3; // weeks_choice&hours_choice height
+ 
+ return ret;
+}
+
+
+
+
+void Fl_Calendar::set_now(){
+ _ts = time(NULL);
+ //struct tm tm; memset(&tm, 0, sizeof(_tm));
+ memcpy(&_tm, localtime(&_ts), sizeof(_tm));
+ //set(tm.tm_mday, tm.tm_mon, tm.tm_year+1900, tm.tm_hour, tm.tm_min, tm.tm_sec);
+ 
+ if(shown()){ _iconaccept->do_callback(); }
+}
+
+
+
+void Fl_Calendar::set(bool utc, time_t t){
+ _ts = t;
+ struct tm tm; memset(&tm, 0, sizeof(_tm));
+ if(utc){ memcpy(&tm, gmtime(&_ts), sizeof(_tm)); }
+ else { memcpy(&tm, localtime(&_ts), sizeof(_tm)); }
+ set(tm.tm_mday, tm.tm_mon, tm.tm_year+1900, tm.tm_hour, tm.tm_min, tm.tm_sec);
+ 
+ if(shown()){ _iconaccept->do_callback(); }
+}
+
+// cd ../ && rm src/Fl_Calendar.o && make
+void Fl_Calendar::set(const char* str, const char *fmt){
+ if(str == NULL || fmt == NULL){ return ; }
+ struct tm tm; memset(&tm, 0, sizeof(_tm));
+ if(strptime(str, fmt, &tm) != NULL){
+  _ts = timelocal(&tm);
+//   memcpy(&_tm, &tm, sizeof(_tm));
+//   _iconaccept->do_callback();
+  set(tm.tm_mday, tm.tm_mon, tm.tm_year+1900, tm.tm_hour, tm.tm_min, tm.tm_sec);
+  
+  if(shown()){ _iconaccept->do_callback(); }
+ }
+}
+
+
+void Fl_Calendar::set(struct tm *tm){
+ if(tm == NULL){ return ; }
+ _ts = timelocal(tm);
+ //struct tm tm; memset(&tm, 0, sizeof(_tm));
+ memcpy(&_tm, tm, sizeof(_tm));
+ set(tm->tm_mday, tm->tm_mon, tm->tm_year+1900, tm->tm_hour, tm->tm_min, tm->tm_sec);
+ 
+ if(shown()){ _iconaccept->do_callback(); }
+}
+
+
+
+time_t Fl_Calendar::get(bool utc, struct tm *tm){
+ time_t ret = -1;
+ 
+ if(utc){ ret = timegm(&_tm); }
+ else { ret = timelocal(&_tm); }
+ 
+ if(tm != NULL){ memcpy(tm, &_tm, sizeof(_tm)); }
+ 
+ return ret;
+}
+
+
+
+int Fl_Calendar::get(const char *fmt, char *out, int szout){
+ if(fmt == NULL || out == NULL || szout < 1){ return 0; }
+ return strftime(out, szout, fmt, &_tm);
+}
+
+
+
+void Fl_Calendar::readonly(bool f){
+ _rdo = f;
+ 
+ if(f){
+  _iconupdate->deactivate(); _iconupdate->redraw();
+  _iconaccept->deactivate(); _iconaccept->redraw();
+  _clocks->type(FL_READONLY_CLOCK_SPINNER); _clocks->redraw();
+  if(parent() != NULL){ _iconcancel->deactivate(); }
+ }
+ else {
+  _iconupdate->activate(); _iconupdate->redraw();
+  _iconaccept->activate(); _iconaccept->redraw();
+  _clocks->type(FL_NORMAL_CLOCK_SPINNER); _clocks->redraw();
+  if(parent() == NULL){ _iconcancel->activate(); }
+ }
+ 
+}
+
+
+
+
+
+
+void Fl_Calendar::activate(){
+ Fl_Menu_Window::activate();
+ Fl_Widget *const*a = array();
+ Fl_Widget* p;
+ for (int i = children(); i --; a ++){ p = (Fl_Widget*)*a; p->activate(); }
+ readonly(_rdo);
+}
+
+
+void Fl_Calendar::deactivate(){
+ Fl_Menu_Window::deactivate();
+ Fl_Widget *const*a = array();
+ Fl_Widget* p;
+ for (int i = children(); i --; a ++){ p = (Fl_Widget*)*a; p->deactivate(); }
+}
+
+
+
+
+
+
+void Fl_Calendar::preferences(Fl_Calendar_Prefs *p){
+ if(p == NULL){ p = &_prefs; }
+ 
+ color(fl_lighter(FL_BACKGROUND_COLOR));
+ label(p->_header);
+ 
+ // TODO : needs to end its copying
+ if(p != &_prefs){
+  memcpy(_prefs._headercolor, p->_headercolor, sizeof(_prefs._headercolor));
+  memcpy(_prefs._monthscolor, p->_monthscolor, sizeof(_prefs._monthscolor));
+  memcpy(_prefs._dayscolor, p->_dayscolor, sizeof(_prefs._dayscolor));
+  memcpy(_prefs._size_fonts, p->_size_fonts, sizeof(_prefs._size_fonts));
+  memcpy(_prefs._attr_fonts, p->_attr_fonts, sizeof(_prefs._attr_fonts));
+  memcpy(_prefs._fonts, p->_fonts, sizeof(_prefs._fonts));
+ }
+ 
+ _header->labelcolor(p->_headercolor[1]);
+ _header->labelsize(p->_size_fonts[0]);
+ _header->labelfont(p->_fonts[0]);
+ 
+ _icon->image(p->_icon);
+ _icon->deimage(p->_deicon);
+ 
+ _months->labelcolor(p->_monthscolor[1]);
+ _months->labelsize(p->_size_fonts[1]);
+ _months->labelfont(p->_fonts[1]);
+ 
+ int oi = _months->value();
+ _months->clear();
+ for(int _i = 0; _i < 12; _i++){
+  _months->add(p->_months[_i]);
+  Fl_Menu_Item &item = (Fl_Menu_Item &)(_months->menu()[_i]);
+  item.labelcolor(p->_monthscolor[1]);
+  item.labelsize(p->_size_fonts[1]);
+  item.labelfont(p->_fonts[1]);
+ }
+ _months->value(oi);
+ 
+ _years->labelcolor(p->_monthscolor[1]);
+ _years->labelsize(p->_size_fonts[1]);
+ _years->labelfont(p->_fonts[1]);
+ 
+ for(int _i = 0; _i < 7; _i++){
+  _nmdays[_i]->label(p->_days[_i]);
+  _nmdays[_i]->labelcolor(p->_dayscolor[1]);
+  _nmdays[_i]->labelsize(p->_size_fonts[1]);
+  _nmdays[_i]->labelfont(p->_fonts[1]);
+ }
+ 
+ for(int _i = 0; _i < 6; _i++){
+  _nweeks[_i]->labelcolor(p->_dayscolor[0]);
+  _nweeks[_i]->labelsize(p->_size_fonts[2]);
+  _nweeks[_i]->labelfont(p->_fonts[2]);
+ }
+ 
+ 
+ for(int _i = 0; _i < 42; _i++){
+  _days[_i]->selection_color(p->_dayscolor[2]);
+  _days[_i]->labelsize(p->_size_fonts[2]);
+  
+  if(_sdays[_i] == -1 || _sdays[_i] == 1){ _days[_i]->labelcolor(p->_dayscolor[0]); }
+  else { _days[_i]->labelcolor(p->_dayscolor[1]); }
+  
+ }
+ 
+ _iconupdate->tooltip(p->_icontooltips[0]);
+ _iconreset->tooltip(p->_icontooltips[1]);
+ _iconaccept->tooltip(p->_icontooltips[2]);
+ _iconcancel->tooltip(p->_icontooltips[3]);
+ 
+ if(parent() != NULL){ _iconcancel->deactivate(); }
+ else if(!_rdo){ _iconcancel->activate(); }
+ 
+ redraw();
+ 
+}
+
+
+
+
+
+
+
+ int Fl_Calendar::handle(int e){
+  if(!visible() || !active_r()){ return 0; }
+  static int x1=0, y1=0, xoff=0,yoff=0;
+  
+  bool is_parent = (parent() != NULL);
+  Fl_Widget *o = Fl::belowmouse();
+  int index = -1;
+  if(o != this && o != _header){
+   for(int _i = 0; _i < 42; _i++){ if(o == _days[_i]){ index = _i; break; } }
+  }
+  
+  switch(e){
+   case FL_PUSH:{
+    if(o != this && o != _header){
+     if(index != -1){
+      Fl_Button *day = _days[index];
+      int nm, ny, nd, wi, hour, min;
+      if(Fl::event_clicks()){ // double click
+       if((day->down_box() != FL_DOWN_BOX && !day->value()) || _rdo){ return 0; }
+       
+       if(shown()){ Fl::pushed(_iconaccept); _iconaccept->do_callback(); }
+       //char str[128]; get("%F %T", str, 128); printf("str: %s\n", str);
+       if(!is_parent &&_cach){ hide(); return 1; }
+       else { return 1; }
+      }
+      else{ // single click
+        if(day->down_box() != FL_DOWN_BOX && day->value()){ return 0; }
+        else {
+         if(_sel != NULL && _sel->down_box() != FL_DOWN_BOX){ _sel->value(0); }
+         
+         nm = (int)_months->value();
+         ny = (int)_years->value();
+         nd = strtol(day->label(), NULL, 10);
+         hour = _clocks->hours();
+         min = _clocks->minutes();
+         
+         if(_sdays[index] == -1){ // day of previous month
+          nm--; if(nm < 0){ nm = 11; ny--; }
+         }
+         else if(_sdays[index] == 1){ // day of next month
+          nm++; if(nm > 11){ nm = 0; ny++; }
+         }
+         else { // day of current month
+          day->value(1); _sel = day; wi = index/7;
+          _weeks->value(strtol(_nweeks[wi]->label(), NULL, 10)); 
+         }
+         set(nd, nm, ny, hour, min, 0);
+         //if(_sel != NULL){ _sel->redraw_label(); }
+         return 1;
+        }
+      }
+     }
+     
+     break;
+    }
+    else if(!is_parent){
+     x1 = Fl::event_x_root();
+     y1 = Fl::event_y_root();
+     xoff = x() - x1;
+     yoff = y() - y1;
+     return 1;
+    } else { return 0; }
+    break;
+   }
+   case FL_RELEASE:
+   case FL_DRAG:{
+    if(index != -1){ return 0; }
+    if(o != this && o != _header){ return o->handle(e); }
+    if(is_parent){ return 0; }
+    
+    int nX = xoff + Fl::event_x_root();
+    int nY = yoff + Fl::event_y_root();
+    
+    int W2 = 0, H2 = 0, X2 = 0, Y2 = 0;
+    Fl::screen_work_area(X2, Y2, W2, H2);
+    
+    if(nX < 0){ nX = 0; }
+    else if(nX > W2-w()){ nX = W2-w(); }
+    if(nY < 0){ nY = 0; }
+    else if(nY > H2-h()){ nY = H2-h(); }
+    position(nX, nY);
+    return 1;
+   }
+   
+   default: break;
+  }
+  
+  return Fl_Menu_Window::handle(e);
+ }
+ 
+ 
+ 
+#endif
